﻿# Project: lego quickstart program
# Created By: Tufts CEEO - Chris Roger's Lab
# Contributers: Ian Gray, Kevin O'Brien, George Pesmazoglou
# Last Modified: June 15, 2016

FILES IN REPO (See below for file descriptions):

-- FOLDERS --
ARCHIVE - folder for out-dated files
VIDEO_MATERIALS - folder for materials pertaining to the video for this project.
-- DOCUMENTATION --

README.md - description of the whole project repo
TODO.txt - List of task to do related to the project

-- MAIN VI --
EV3_Quickstart.vi

-- SUB VI's --
sensor_identifier.vi
motor_detection.vi
no_motor_color_sensor.vi
no_motor_gyro_sensor.vi
no_motor_touch_sensor.vi
no_motor_ultrasonic_sensor.vi
one_motor_color_sensor.vi
one_motor_gyro_sensor.vi
one_motor_no_sensor.vi
one_motor_touch_sensor.vi
one_motor_ultrasonic_sensor.vi
three_motor_no_sensor.vi
two_motor_color_sensor.vi
two_motor_gyro_sensor.vi
two_motor_no_sensor.vi
two_motor_touch_sensor.vi
two_motor_ultrasonic_sensor.vi

+--------------------------------------------------------------------------------------------------------------------------------+
|--------------------------------------------------------------------------------------------------------------------------------|
|--------------------------------------------------------FILE DESCRIPTIONS-------------------------------------------------------|
|--------------------------------------------------------------------------------------------------------------------------------|
+--------------------------------------------------------------------------------------------------------------------------------+

MAIN VI -
EV3_Quickstart.vi - Auto-detects what/how many sensors/motors are connected to the EV3 Brick and runs the corresponding subVI
 depending on what combination of components is connected. 

SUB VI'S -

sensor_identifier.vi - Uses the EV3 Invoke Node to determine what value is being read at each sensor port in the EV3 Brick.
 This VI returns two arrays: one with the sensor value and a second with the corresponding port number for each sensor value. 

motor_detection.vi - Attempts to turn a motor in each port one degree to test if the motor encoder moves, which allows us
 to see if a motor is connected. This VI returns an array listing all of the ports that have a motor. 

no_motor_color_sensor.vi - Takes an input of which port the color sensor is connected to, and plays a tone from the EV3 Brick
 that varies in pitch based on how much light the sensor sees. 

no_motor_gyro_sensor.vi - Takes an input of which port the gyro sensor is connected to, and plays a tone from the EV3 Brick
 that varies in pitch based on the rotational position of the gyro sensor. 

no_motor_touch_sensor.vi - Takes an input of which port the touch sensor is connected to, and plays a tone from the EV3 Brick 
each time the button is pressed. Also, keeps a running count of the number of button presses and displays it on the EV3 Brick's
screen.

no_motor_ultrasonic_sensor.vi - Takes an input of which port the ultrasonic sensor is connected to, and beeps repeatedly when 
an object comes within 1 meter of the sensor. 

one_motor_color_sensor.vi - Takes an input of color sensor port and motor port, and drives the motor at a speed proportional to
 the amount of light the sensor sees.

one_motor_gyro_sensor.vi - Takes an input of gyro sensor port and motor port, and drives the motor either forward backward at a
 speed proportional to the relative angular position of the gyro sensor. 

one_motor_no_sensor.vi - Takes an input of motor port, and drives the motor forward and backward when the up and down buttons 
 on the EV3 Brick are pressed, respectively.

one_motor_touch_sensor.vi - Takes an input of touch sensor port and motor port, and alternates between driving the motor forward
 and backward with each button press. 

one_motor_ultrasonic_sensor.vi - Takes an input of ultrasonic sensor port and motor port, and oscillates the motor along 120° when
 can object comes within 1 meter of the sensor.

three_motor_no_sensor.vi - Runs the first two motors and steers them based on the angular input into the third motor.

two_motor_color_sensor.vi - Takes an input of color sensor port and two motor ports, and steers the motors using a proportional
 controller based on the amount of light the sensor sees. This is especially useful in creating a line following robot.

two_motor_gyro_sensor.vi - Takes an input of gyro sensor port and two motor ports, and drives the motors in a direction proportional
 to the relative angular position of the gyro sensor.

two_motor_no_sensor.vi - Takes an input of motor ports, and moves forward, backward, left, or right depending on which direcitonal
 button on the EV3 Brick was last pressed. 

two_motor_touch_sensor.vi - Takes an input of touch sensor port and two motor ports. Motors drive forward when touch sensor is pressed,
 and back up and turn when it is not pressed. This is especially useful in creating a robot that doesn't fall off a table. 

two_motor_ultrasonic_sensor.vi - Takes an input of ultrasonic sensor port and two motor ports. Motors drive forward when there is not an
 object within 30 cm. When an objects gets within 30 cm, the motors back up and turn. This is especially useful in creating a robot that
 does not crash into walls. 

+--------------------------------------------------------------------------------------------------------------------------------+
|--------------------------------------------------------------------------------------------------------------------------------|
|---------------------------------------------------------NON VI BEHAVIORS-------------------------------------------------------|
|--------------------------------------------------------------------------------------------------------------------------------|
+--------------------------------------------------------------------------------------------------------------------------------+

No motor no sensor - When no motors or sensors are plugged in, the EV3 prompts the user via the screen and a beep to add additional
 components and run the program again.

Two motor two sensor - When two motors and two sensors are plugged in, the robot will combine the behaviors of the two sensors, each one
 one motor through its respective one_motor_<SENSOR_TYPE>_sensor.vi.

Three motor one sensor - The first sensor plugged in will control the first two motors, while the third motor will behave according to the
 one_motor_no_sensor.vi.

Three motor two sensors - The first sensor plugged in will control the first two motors, while the third motor will be controlled by the
 corresponding one_motor_<SENSOR_TYPE>_sensor.vi.

Three motor three sensor - Each motor will be controlled by one of the sensors, running the coresponding one_motor_<SENSOR_TYPE>_sensor.vi
 for each sensor plugged into the EV#
 


